# Howto gitit

<https://github.com/jgm/gitit/tree/master/>

## Installation

### Paquet Debian (version 0.10)

    # apt install gitit

### Manuellement

    # apt install cabal-install ghc zlib1g-dev
    # adduser gitit
    # sudo -ui gitit
    $ cabal update
    $ cabal install gitit
    $ echo PATH="$HOME/.cabal/bin:$PATH" > ~/.profile

Note : /tmp doit être en EXEC pendant l'installation

## Configuration

    $ gitit --print-default-config > gitit.conf

gitit.conf :

~~~
address: 127.0.0.1
repository-type: Git
repository-path: git
session-timeout: 36000
default-extension: md
default-page-type: Markdown
front-page: index
no-delete: index, Help
use-cache: yes
~~~

/etc/nginx/sites-available/gitit.conf :

~~~
server {
    server_name     gitit.example.com;
    listen          0.0.0.0:80;
    listen          [::]:80;
    location /_register {
        allow 192.0.2.42;
        deny all;
        proxy_pass        http://127.0.0.1:5001/_register;
        proxy_set_header  X-Real-IP  $remote_addr;
        proxy_redirect off;
    }
    location / {
        proxy_pass        http://127.0.0.1:5001/;
        proxy_set_header  X-Real-IP  $remote_addr;
        proxy_redirect off;
    }
    access_log      /var/log/nginx/gitit/access.log;
    error_log       /var/log/nginx/gitit/error.log;
}
~~~

## Lancement

    $ gitit -f gitit.conf


Pour voir la liste des langages supportés pour le highlighting :

    $ pandoc -v